Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3791)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3792)
@@ -6675,171 +4129,72 @@
 
 
-   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
-                                   r2z, logc, logc_ratio, logc_kbounds,        &
-                                   nzt_topo_nestbc,                            &
-                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
-                                   edge, var )
-!
-!--   Interpolation of ghost-node values used as the child-domain boundary
-!--   conditions. This subroutine handles the left and right boundaries. It is
-!--   based on trilinear interpolation.
+   SUBROUTINE pmci_anterp_tophat( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc, var )
+!
+!--   Anterpolation of internal-node values to be used as the parent-domain
+!--   values. This subroutine is based on the first-order numerical
+!--   integration of the child-grid values contained within the anterpolation
+!--   cell.
 
       IMPLICIT NONE
 
-      INTEGER(iwp) ::  nzt_topo_nestbc   !<
-
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                                      INTENT(INOUT) ::  f       !<
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
-                                      INTENT(IN)    ::  fc      !<
-      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nys:nyn),          &
-                                      INTENT(IN)    ::  logc_ratio   !<
-!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !<
-!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x     !<
-!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y     !<
-!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y     !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x     !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x     !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y     !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y     !<
-
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z     !<
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z     !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z     !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z     !<
-      
-
-      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic     !<
-      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc     !<
-!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc     !<
-      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                &
-                                          INTENT(IN)           :: logc   !<
-      INTEGER(iwp), DIMENSION(1:2,nys:nyn), INTENT(IN)         :: logc_kbounds !<
-
-      INTEGER(iwp) :: kct
-
-!AH
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(IN) ::  f         !< Child-grid array
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(INOUT)  ::  fc        !< Parent-grid array
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc  !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), INTENT(IN) ::  kct                                             !< Top boundary index for anterpolation along z
       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-!AH
-
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-
-!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-
-      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
-      CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
-
-      INTEGER(iwp) ::  i        !< Lower bound of the running index ia
-      INTEGER(iwp) ::  ia       !< i-index running over the parent-grid cell on the boundary 
-      INTEGER(iwp) ::  iaw      !< Reduced ia-index for workarr_lr
-      INTEGER(iwp) ::  iawbc    !< iaw-index pointing to the boundary-value nodes (either 0 or igsr-1)      
-      INTEGER(iwp) ::  ibc      !< Fixed i-index pointing to the boundary-value nodes (either i or iend)
-!AH      INTEGER(iwp) ::  ibeg     !< i-index pointing to the starting point of workarr_lr in the i-direction 
-      INTEGER(iwp) ::  iend     !< Upper bound of the running index ia
-      INTEGER(iwp) ::  ierr     !< MPI error code
-      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
-      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
-      INTEGER(iwp) ::  j        !< Running index in the y-direction
-      INTEGER(iwp) ::  jco      !<
-      INTEGER(iwp) ::  jcorr    !<
-      INTEGER(iwp) ::  jinc     !<
-      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
-      INTEGER(iwp) ::  j1       !<
-      INTEGER(iwp) ::  k        !< Running index in the z-direction
-      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
-      INTEGER(iwp) ::  kco      !<
-      INTEGER(iwp) ::  kcorr    !<
-      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
-      INTEGER(iwp) ::  k1       !<
-      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
-      INTEGER(iwp) ::  lbeg     !< l-index pointing to the starting point of workarrc_lr in the l-direction 
-      INTEGER(iwp) ::  lp1      !< l+1
-      INTEGER(iwp) ::  loff     !< l-offset needed on the right boundary to correctly refer to boundary ghost points
-      INTEGER(iwp) ::  lw       !< Reduced l-index for workarrc_lr
-      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
-      INTEGER(iwp) ::  mnorthv  !< Upshift by one for the upper bound of index m in case of var == 'v'
-      INTEGER(iwp) ::  mp1      !< m+1
-      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
-      INTEGER(iwp) ::  np1      !< n+1
-      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
-      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
-
-      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
-      REAL(wP) ::  cellsumd     !< Sum of differences over the anterpolation cell 
-      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
-      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
- 
-! 
-!--   Check which edge is to be handled
-      IF ( edge == 'l' )  THEN
-!
-!--      For u, nxl is a ghost node, but not for the other variables
-         IF ( var == 'u' )  THEN
-            i     = nxl
-            iend  = nxl
-            ibc   = nxl
-            iawbc = 0
-            lbeg  = icl
-            loff  = 0
-         ELSE
-            i     = nxl - igsr
-            iend  = nxl - 1
-            ibc   = nxl - 1
-            iawbc = igsr-1
-            lbeg  = icl
-            loff  = 0
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates end index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu !< Indicates end index of child cells belonging to certain parent cell - z direction
+      CHARACTER(LEN=*), INTENT(IN) ::  var                   !< Variable symbol: 'u', 'v', 'w' or 's'
+!
+!--   Local variables:  
+      REAL(wp) ::  cellsum       !< sum of respective child cells belonging to parent cell 
+      INTEGER(iwp) ::  i         !< Running index x-direction - child grid
+      INTEGER(iwp) ::  iclant    !< Left boundary index for anterpolation along x
+      INTEGER(iwp) ::  icrant    !< Right boundary index for anterpolation along x
+      INTEGER(iwp) ::  j         !< Running index y-direction - child grid
+      INTEGER(iwp) ::  jcnant    !< North boundary index for anterpolation along y
+      INTEGER(iwp) ::  jcsant    !< South boundary index for anterpolation along y
+      INTEGER(iwp) ::  k         !< Running index z-direction - child grid     
+      INTEGER(iwp) ::  kcb = 0   !< Bottom boundary index for anterpolation along z
+      INTEGER(iwp) ::  kctant    !< Top boundary index for anterpolation along z
+      INTEGER(iwp) ::  l         !< Running index x-direction - parent grid
+      INTEGER(iwp) ::  m         !< Running index y-direction - parent grid
+      INTEGER(iwp) ::  n         !< Running index z-direction - parent grid
+      INTEGER(iwp) ::  var_flag  !< bit number used to flag topography on respective grid
+
+!
+!--   Define the index bounds iclant, icrant, jcsant and jcnant.
+!--   Note that kcb is simply zero and kct enters here as a parameter and it is
+!--   determined in pmci_init_anterp_tophat.
+!--   Please note, grid points used also for interpolation (from parent to
+!--   child) are excluded in anterpolation, e.g. anterpolation is only from 
+!--   nzb:kct-1, as kct is used for interpolation.
+      iclant = icl
+      icrant = icr
+      jcsant = jcs
+      jcnant = jcn
+      kctant = kct - 1
+      
+      kcb  = 0
+      IF ( nesting_mode /= 'vertical' )  THEN
+         IF ( bc_dirichlet_l )  THEN
+            iclant = icl + 3
          ENDIF
-      ELSEIF ( edge == 'r' )  THEN
-         IF ( var == 'u' )  THEN
-            i     = nxr + 1            
-            iend  = nxr + 1
-            ibc   = nxr + 1 
-            iawbc = 0
-            lbeg  = icr - 2
-            loff  = 0
-         ELSE
-            i     = nxr + 1
-            iend  = nxr + igsr
-            ibc   = nxr + 1
-            iawbc = 0
-            lbeg  = icr - 2
-            loff  = 1
+         IF ( bc_dirichlet_r )  THEN
+            icrant = icr - 3
          ENDIF
 
+         IF ( bc_dirichlet_s )  THEN
+            jcsant = jcs + 3
+         ENDIF
+         IF ( bc_dirichlet_n )  THEN
+            jcnant = jcn - 3
+         ENDIF
       ENDIF
-
-      IF  ( var == 'w' )  THEN
-         ntopw = 1
-      ELSE
-         ntopw = 0
-      ENDIF
-
-      IF  ( var == 'v' )  THEN
-         mnorthv = 0
-      ELSE
-         mnorthv = 1
-      ENDIF
-
+!
+!--   Set masking bit for topography flags 
       IF ( var == 'u' )  THEN 
          var_flag = 1 
